/*
 * Nomad Instrument Control Software
 *
 * Copyright 2011 Institut Laue-Langevin
 *
 * Licensed under the EUPL, Version 1.1 only (the "License");
 * You may not use this work except in compliance with the Licence.
 * You may obtain a copy of the Licence at:
 *
 * http://joinup.ec.europa.eu/software/page/eupl
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the Licence is distributed on an "AS IS" basis,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the Licence for the specific language governing permissions and
 * limitations under the Licence.
 */

#ifndef IKONDEF_H
#define IKONDEF_H


namespace ikon {

enum
{
  READOUT_NOT_ACTIVE = 0,
  EXPOSURE_IN_PROGRESS,
  READOUT_IN_PROGRESS,
  READOUT_COMPLETE,
  FRAME_AVAILABLE = READOUT_COMPLETE,
  READOUT_FAILED,
  ACQUISITION_IN_PROGRESS,
  MAX_CAMERA_STATUS
};

enum
{ ATTR_CURRENT, ATTR_COUNT, ATTR_TYPE, ATTR_MIN, ATTR_MAX, ATTR_DEFAULT,
  ATTR_INCREMENT, ATTR_ACCESS, ATTR_AVAIL
};

enum
{
  TIMED_MODE,
  STROBED_MODE,
  BULB_MODE,
  TRIGGER_FIRST_MODE,
  FLASH_MODE,
  VARIABLE_TIMED_MODE,
  INT_STROBE_MODE
};

enum
{ CCS_NO_CHANGE, CCS_HALT, CCS_HALT_CLOSE_SHTR, CCS_CLEAR,
  CCS_CLEAR_CLOSE_SHTR, CCS_OPEN_SHTR, CCS_CLEAR_OPEN_SHTR
};



#define CAM_NAME_LEN 	32
#define PARAM_SER_SIZE	((2<<16) + (6<<24)     +  58)
#define PARAM_PAR_SIZE	((2<<16) + (6<<24)     +  57)
#define ERROR_MSG_LEN  255

#define DEFAULT_TIME 	0.1
#define DEFAULT_HEIGHT 	2048
#define DEFAULT_WIDTH 	2088

}

#endif //IKONDEF_H
